#[doc = "Register `D11` reader"]
pub struct R(crate::R<D11_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<D11_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<D11_SPEC>> for R {
    fn from(reader: crate::R<D11_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `D11` writer"]
pub struct W(crate::W<D11_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<D11_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<D11_SPEC>> for W {
    fn from(writer: crate::W<D11_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `D1_LS` reader - Data 1 for UDB\\[n\\]"]
pub struct D1_LS_R(crate::FieldReader<u8, u8>);
impl D1_LS_R {
    pub(crate) fn new(bits: u8) -> Self {
        D1_LS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D1_LS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D1_LS` writer - Data 1 for UDB\\[n\\]"]
pub struct D1_LS_W<'a> {
    w: &'a mut W,
}
impl<'a> D1_LS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u16 & 0xff);
        self.w
    }
}
#[doc = "Field `D1_MS` reader - Data 1 for UDB\\[n+1\\]"]
pub struct D1_MS_R(crate::FieldReader<u8, u8>);
impl D1_MS_R {
    pub(crate) fn new(bits: u8) -> Self {
        D1_MS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D1_MS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D1_MS` writer - Data 1 for UDB\\[n+1\\]"]
pub struct D1_MS_W<'a> {
    w: &'a mut W,
}
impl<'a> D1_MS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | ((value as u16 & 0xff) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Data 1 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn d1_ls(&self) -> D1_LS_R {
        D1_LS_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Data 1 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn d1_ms(&self) -> D1_MS_R {
        D1_MS_R::new(((self.bits >> 8) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Data 1 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn d1_ls(&mut self) -> D1_LS_W {
        D1_LS_W { w: self }
    }
    #[doc = "Bits 8:15 - Data 1 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn d1_ms(&mut self) -> D1_MS_W {
        D1_MS_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Data 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [d11](index.html) module"]
pub struct D11_SPEC;
impl crate::RegisterSpec for D11_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [d11::R](R) reader structure"]
impl crate::Readable for D11_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [d11::W](W) writer structure"]
impl crate::Writable for D11_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets D11 to value 0"]
impl crate::Resettable for D11_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
